#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_map>

using namespace std;


int main() {
    cin.sync_with_stdio(false);
    cin.tie(0);

    long long n,k, m;
    cin>> n;

    string s;
    cin>>s;

    unordered_map<vector<bool>, int> muj_dict;

    vector<bool> act_set('t' - 'a', false);
    muj_dict[act_set] = -1;


    int res =0;
    for (int i = 0; i < s.size(); ++i) {
        int cislo = s[i] - 'a';
        act_set[cislo] = ! act_set[cislo];
        vector<bool> neib_set(act_set);
        for (int j = 0; j < 't' - 'a' + 1; ++j) {
            neib_set[j] = !neib_set[j];
            if (muj_dict.find(neib_set) != muj_dict.end()){
                res = max(res, i - muj_dict[neib_set]);
            }
            neib_set[j] = !neib_set[j];
        }
        if (muj_dict.find(act_set) == muj_dict.end()){
            muj_dict[act_set] = i;
        }
    }
    std::cout << res << std::endl;
    return 0;
}